<?php
/***************************************************************************
 *                               reorg.php
 *                            FB2IMP2 functions
 *                            -------------------
 *   begin                : Sunday, May 2, 2010
 *   copyright            : (C) 2010 Ulrich Schroeter
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License', or
 *   ('at your option) any later version.
 * See the LICENSE file for more information.
 * DLIMP Website : http://ambrosia60.dnsalias.net/
 *----------------------------------------------------------------------------
 */

define('REORG',1);

//=================================================

/* ---------  begin funtions ------------------------------ */

function strcrc32($text) {
  $crc = crc32($text);
  if ($crc & 0x80000000) {
    $crc ^= 0xffffffff;
    $crc += 1;
    $crc = -$crc;
  }
  return $crc;
}

function int32_to_hex($value) {
  $value &= 0xffffffff;
  return str_pad(strtoupper(dechex($value)), 8, "0", STR_PAD_LEFT);
} 

//    if (savemsg($ftscdateA,$datetime,$folder,$fromnode,$tonode,$fromname,$toname,$subject,$cattrib,$msgid,$replyid,$origin,$msgpath,$clocal,$crcvd,$csend,$kludges,$body,$seenby,$datewritten,$cuplink)) {
// id         561925,
// $ftscdateA  *ftscdate   '08 Dec 09  21:37:40'   (msg date/time ???)
// $datetime   *datetime   2009-12-08 21:45:22     (???)
// $folder     *folder     'FIDOCON.BLEICHENBACH.1996'
// $fromnode   *fromnode   '2:244/1120@fidonet'     pkt-from transfer
// $tonode     *tonode     '2:2443/1313'            pkt-to   transfer
// $fromname   *fromname   'Tina Kramp'
// $toname     *toname     'Michael Muetterlein'
// $subject    *subject    'allein im Echo'
// $cattrib    c attrib     0
// $msgid      *msgid      '2:240/2188.262 4b1eb95e'
// $replyid    *replyid    '2:244/1117 960ba4e5'
// $origin     *origin     'www.fido-deluxe.de.vu    Fido-Paket -IP- deluxe (2:240/2188.262)'
// $msgpath    *path       '240/2188 244/1120'
// $clocal     c local      'N'
// $crcvd      c rcvd       'Y'
// $csend      c send       'N'
// $kludges    *kludges    ''   (blob)   01h...0Dh 0Ah 01h ... 0Dh 0Ah 01h ... 0Dh 0Ah  all Ctrl+A lines w/o seenby
// $body       *body       ''   (blob)   AREA:FIDOCON.BLEICHENBACH.1996 0Dh 01h ...  incl. header kludges w/o origin
// $seenby     *seenby     ''   (blob)   ...  0Dh
// $datewritten *datewritten '2009-12-08 21:37:40'      (import date/time)
// $cuplink    c Uplink     0                            ???
function savemsg($msgf,$ftscdateA,$datetime,$folder,$fromnode,$tonode,$fromname,$toname,$subject,$cattrib,$msgid,$replyid,$origin,$msgpath,$clocal,$crcvd,$csend,$kludges,$body,$seenby,$datewritten,$cuplink) {
  global $prefix, $db2, $dbname2, $br;
  global $imperr;  
  global $savmsg, $dupechkscnd;  
  $tbl = "echo_".substr($folder,0,1);
  $insert1 = "INSERT INTO ".$dbname2.".".$tbl." VALUES (NULL,'".$ftscdateA."', '".$datetime."', '".$folder."', '".$fromnode."', '".$tonode."','".$fromname."', '".$toname."', '".$subject."', ".$cattrib.", '".$msgid."', '".$replyid."', '".$origin."','".$msgpath."', '".$clocal."', '".$crcvd."', '".$csend."', '".$kludges."', '".$body."', '".$seenby."', '".$datewritten."',".$cuplink.")";
  if ($savmsg) {
    if (!$db2->sql_query($insert1)) {
      $imperr++;
      logfile('E',"insert message failed: ".$msgf);
      logfile('L',"insert message failed: ".$msgf);
      logfile('D',"insert message failed: ".$msgf);
      $sqle = $db2->sql_error($insert1);
      logfile('D',"ERROR: insert record failed '".$tbl."': ".$insert1);
      logfile("D","ERROR: SQL error: (".($sqle['code']).") ".($sqle['message']));
      // echo "Insert failed: Sysop: ".$sn." => ".$sysopshort."\r\n";
    } else {
      // logfile('L', "insert message success: ".$msgf);
      // logfile('D', "insert message success: ".$msgf.", table: '".$tbl."', folder: '".$folder."'");
      return True;
    }
  } else {
    logfile('D', "insert message success: ".$msgf.", table: '".$tbl."', folder: '".$folder."'");
    return True;
  }
  return False;
}

function strip0A($text) {
  $text = preg_replace("/\r\n/","\r",$text);  
  return $text;
}


// includes 0Dh+0Ah to 0Dh replacement
function stripkludge($text) {
  while (index($text,chr(1))>=0) {
    $y = index($text,chr(1));
    if ($y >=0) {
      $text = substr($text,$y+1);
    }
  }
  $text = substr($text,index($text,chr(13))+1);
  $text = substr($text,0,rat("---",$text));  
  $text = strip0A($text);  
  return $text;
}

//  if (!dupefind($folder,$ftscdateA,$msgid,$subject)) {
function dupefind($msgf,$fld,$fdat,$msgid,$subj,$body) {
  // SELECT * FROM fidobase2.echo_f where `folder`='FIDOCON.BLEICHENBACH.1996' and `ftscdate` like '08 Dec 09  21:20:4%' and `msgid`='2:240/2188.262 4b1eb5bf' and `subject`='4. - 6. Juni  2010';  
  global $prefix, $db2, $dbname2, $br;  
  global $dpnfftscd,$dpnfsubj,$dpnfsuRe,$dpnfsuReMsg,$dpnfsuReDb;
  global $savmsg, $dupechkscnd;  
  
  // test seconds 0=no, 1=yes   17 or 18 chars
  // 01 Sep 09  01:02:00

  // TEST all   ftscdate (maybe mismatched), subject (may include Umlauts, escaped chars, RE's)

  $q2 = "select id from ".$dbname2.".echo_".substr($fld,0,1)." where `folder`='".$fld."' and `ftscdate` like '".substr($fdat,0,17+$dupechkscnd)."%' and `msgid`='".$msgid."' and `subject`='".$subj."';";
  // echo $short2U."\r\n";
  $res2 = $db2->sql_query($q2);
  if ($row2 = $db2->sql_fetchrow($res2)) {
    // no problem with escaped subject, no problems with included Re:'s
    $db2->sql_freeresult($res2);
    return 1;     
  } else {
    // problem with escaped subject ?, problem with Re:'s, problem with Umlauts ?
    // if (preg_match("/Re[\^d{1,2}]:/",$subj))
    // sollte nicht mehr sein, da "vorher" normalized 

    // search msgid
    // compare each pattern individualy


    $q2 = "select * from ".$dbname2.".echo_".substr($fld,0,1)." where `msgid`='".$msgid."';";
    $res2 = $db2->sql_query($q2);
    if ($db2->sql_numrows($res2) > 0) {
      $ii = 0;
      $imax = 0;
      $imp  = 0;
      $crcbody = stripkludge($body);
      $crc1    = int32_to_hex( strcrc32($crcbody));      
      while ($row2 = $db2->sql_fetchrow($res2)) {
        // at least one record found
        // folder,ftscdate,msgid,subject
        $ii++;
        $t_id[$ii]       = intval($row2['id']);
        $t_folder[$ii]   = $row2['folder']; 
        $t_ftscdate[$ii] = substr($row2['ftscdate'],0,19);
        $t_msgid[$ii]    = $row2['msgid'];
        $t_subject[$ii]  = stripslashes($row2['subject']);
        $t_body[$ii]     = stripkludge(stripslashes($row2['body']));        
        $t_count[$ii]    = 0;
        if ($fld==$t_folder[$ii]) {
          $t_count[$ii] = $t_count[$ii] + 1000;
          if ($msgid==$t_msgid[$ii]) {
            // subject variations
            if (strlen($subj)==strlen($t_subject[$ii])) {
              // subject identical or only same length ?
              if ($subj==$t_subject[$ii]) {
                $t_count[$ii] = $t_count[$ii] + 1000;                
              } else {
                // > 67 % identical ?
                // else, do we have more records ?
                $ccnt = 0;
                for ($j=0;$j<strlen($t_subject[$ii]);$j++) {
                  if (substr($subj,$j,1)==substr($t_subject[$ii],$j,1)) {
                    $ccnt++;
                  }
                }
                // x##_
                $t_count[$ii] = $t_count[$ii] + (intval($ccnt*100/strlen($t_subject[$ii]))*10);                
              }               
            } else {
              // subject variation ?!?
              if (strlen($subj)<strlen($t_subject[$ii])) {
                $ccnt = 0;
                for ($j=0;$j<strlen($subj);$j++) {
                  if (substr($subj,$j,1)==substr($t_subject[$ii],$j,1)) {
                    $ccnt++;
                  }
                }
                // x##_
                $t_count[$ii] = $t_count[$ii] + (intval($ccnt*100/strlen($t_subject[$ii]))*10);                              
              } elseif (strlen($subj)>strlen($t_subject[$ii])) {
                $ccnt = 0;
                for ($j=0;$j<strlen($t_subject[$ii]);$j++) {
                  if (substr($subj,$j,1)==substr($t_subject[$ii],$j,1)) {
                    $ccnt++;
                  }
                }
                // x##_
                $t_count[$ii] = $t_count[$ii] + (intval($ccnt*100/strlen($subj))*10);                              
              } else {
                // ???
              }                          
            }
            // ftscdate variations

            //  +/- 1 or 2 hours ?
            $d1 = $fdat;
            $d2 = $t_ftscdate[$ii];
            $t2 = False;
            if (strtotime($d1) < strtotime($d2)) {
              if ( ((strtotime($d1)+(60*60))==(strtotime($d2))) || ((strtotime($d1)+((60*60)*2))==(strtotime($d2))) ) {
                $t_count[$ii] = $t_count[$ii] + 1000;                
              } else {
                $t2 = True;
              }
            } else {
              if ( ((strtotime($d2)+(60*60))==(strtotime($d1))) || ((strtotime($d2)+((60*60)*2))==(strtotime($d1))) ) {
                $t_count[$ii] = $t_count[$ii] + 1000;
              } else {
                $t2 = True;              
              }                          
            }
            if ($t2) {
              $ccnt = 0;
              for ($j=0;$j<strlen($t_ftscdate[$ii]);$j++) {
                if (substr($fdat,$j,1)==substr($t_ftscdate[$ii],$j,1)) {
                  $ccnt++;
                }
              }
              // ccnt max = 19
              $t_count[$ii] = $t_count[$ii] + intval($ccnt/2);
            }
            // body check ?
            $crc2 = int32_to_hex( strcrc32($t_body[$ii]) );
            if ($crc1==$crc2) {
              $t_count[$ii] = $t_count[$ii] + 10000;
            } else {
              if (strlen($crcbody)==strlen($t_body[$ii])) {
                $fdiff = 0;
                for ($kk=0;$kk<strlen($crcbody);$kk++) {
                  if (substr($crcbody,$kk,1)==substr($t_body[$ii],$kk,1)) {
                    $fdiff = $kk;
                  } else {
                    $kk = strlen($crcbody);   // break
                  }
                }
                logfile('D', "rec(".$msgf.") id      : ".$t_id[$ii]);        
                logfile('D', " len body 1 / crc: ".strlen($crcbody).", ".$crc1);              
                logfile('D', " len body 2 / crc: ".strlen($t_body[$ii]).", ".$crc2);
                logfile('D', "difference(s):");        
                logfile('D', "body 1: ".substr($crcbody,$fdiff,40));              
                logfile('D', "body 2: ".substr($t_body[$ii],$fdiff,40));              
              } else {
                logfile('D', "rec(".$msgf.") id      : ".$t_id[$ii]);        
                logfile('D', " len body 1 / crc: ".strlen($crcbody).", ".$crc1);              
                logfile('D', " len body 2 / crc: ".strlen($t_body[$ii]).", ".$crc2);
              }
            }                            
          // else skip
          }
        // else skip
        }
        //  auswertung counter 1
        if ($t_count[$ii]>$imax) {
          $imax = $t_count[$ii];
          $imp  = $ii;
        }
      }      
      //  auswertung counter 2
      if ($imax > 10000) {
        // ist ein dupe
        /*
        logfile('D', "searching");        
        logfile('D', "       msgid   : ".$msgid);
        logfile('D', "       folder  : ".$fld);
        logfile('D', "       ftscdate: ".$fdat);
        logfile('D', "       subject : ".$subj);
        for ($j=1;$j<=$ii;$j++) {
          logfile('D', "rec(".$j.") id      : ".$t_id[$j]);        
          logfile('D', "       msgid   : ".$t_msgid[$j]);
          logfile('D', "       ftscdate: ".$t_ftscdate[$j]);
          logfile('D', "       subject : ".$t_subject[$j]);
          logfile('D', "       weight  : (".$t_count[$j].")");          
        }
        */
        logfile('D', "dupe found: ".$msgf.", weight: (".$imax.")");        
        $db2->sql_freeresult($res2);
        $rval = 1;
      } elseif ($imax > 2000) {
        // ist sehr wahrscheinlich ein dupe
        /*
        logfile('D', "searching");        
        logfile('D', "       msgid   : ".$msgid);
        logfile('D', "       folder  : ".$fld);
        logfile('D', "       ftscdate: ".$fdat);
        logfile('D', "       subject : ".$subj);


        for ($j=1;$j<=$ii;$j++) {
          logfile('D', "rec(".$j.") id      : ".$t_id[$j]);        
          logfile('D', "       msgid   : ".$t_msgid[$j]);
          logfile('D', "       folder  : ".$t_folder[$j]);
          logfile('D', "       ftscdate: ".$t_ftscdate[$j]);
          logfile('D', "       subject : ".$t_subject[$j]);
          logfile('D', "       weight  : (".$t_count[$j].")");          
        }
        */
        logfile('D', "dupe found: ".$msgf.", weight: (".$imax.")");        
        $db2->sql_freeresult($res2);
        $rval = 2;
      } elseif ($imax > 1670) {
        // sehr wahrscheinlich ein dupe
        /*
        logfile('D', "searching");        
        logfile('D', "       msgid   : ".$msgid);
        logfile('D', "       folder  : ".$fld);
        logfile('D', "       ftscdate: ".$fdat);
        logfile('D', "       subject : ".$subj);


        for ($j=1;$j<=$ii;$j++) {
          logfile('D', "rec(".$j.") id      : ".$t_id[$j]);        
          logfile('D', "       msgid   : ".$t_msgid[$j]);
          logfile('D', "       folder  : ".$t_folder[$j]);
          logfile('D', "       ftscdate: ".$t_ftscdate[$j]);
          logfile('D', "       subject : ".$t_subject[$j]);
          logfile('D', "       weight  : (".$t_count[$j].")");          
        }
        */
        logfile('D', "probably dupe found: ".$msgf.", weight: (".$imax.")");        
        $db2->sql_freeresult($res2);
        $rval = 3;        
      } else {
        /*        
        logfile('D', "searching");        
        */
        if ($fld==$t_folder[1]) {
          logfile('D', "differences found (same folder): ".$msgf);        
          logfile('D', "       msgid   : ".$msgid);
          logfile('D', "       folder  : ".$fld);
          logfile('D', "       ftscdate: ".$fdat);
          logfile('D', "       subject : ".$subj);
          for ($j=1;$j<=$ii;$j++) {
            logfile('D', "rec(".$j.") id      : ".$t_id[$j]);        
            logfile('D', "       msgid   : ".$t_msgid[$j]);
            logfile('D', "       folder  : ".$t_folder[$j]);
            logfile('D', "       ftscdate: ".$t_ftscdate[$j]);
            logfile('D', "       subject : ".$t_subject[$j]);
            logfile('D', "       weight  : (".$t_count[$j].")");          
          }
        } else {
          logfile('D', "differences found (different folder): ".$msgf);
        }        
        $db2->sql_freeresult($res2);
        $rval = 0;
      }
      unset($t_id);
      unset($t_folder); 
      unset($t_ftscdate);
      unset($t_msgid);
      unset($t_subject);
      unset($t_body);        
      unset($t_count);
      unset($row2);
      return $rval;      
    } else {
      // nothing found
      return 0;
    }
        
  }
}



function umlaut($subj) {
  // 98h 152d
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","oe",$subj);
  } 
  // 99h 153d
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","Oe",$subj);
  }

  // 81h  129d
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","ue",$subj);
  } 
  // 9ah 154d
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","Ue",$subj);
  } 
  // E1h 225d
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","ss",$subj);
  } 
  // F6h  246d
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","oe",$subj);
  }  
  // 8Eh  142d
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","Ae",$subj);
  }  
  // 84h  132d
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","ae",$subj);
  }  
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","ae",$subj);
  } 
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","oe",$subj);
  } 
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","ue",$subj);
  } 
  
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","Ae",$subj);
  } 
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","Oe",$subj);
  } 
  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","Ue",$subj);
  } 

  while (preg_match("//",$subj)) {
    $subj = preg_replace("//","ss",$subj);
  } 
  
  return $subj;
}

function refn($mode=0,$subj,$patt="") {
  // mode = 0  detect
  // mode = 1  replace
  if (preg_match("/^Re(\^\d+){0,1}:/",$subj)) {
    // if (preg_match("/^(Re\^\d{1,2}|Re)\:/",substr($subj,0,5))) {
    // echo "pregmatch found: ".$subj."\r\n";
    if ($mode==0) {
      return True;
    } else {
      if  (preg_match("/^Re:/",$subj)) {
        // simple Re: ... Re: ...
        while (substr($subj,0,3)=="Re:") {
          $subj = trim(substr($subj,at("Re:",$subj)+3));
        } 
      } else {
        $subj = trim(preg_replace("/^Re(\^\d+){0,1}:/",$patt,$subj));
      }
      return $subj;
    }
  } else {
    // echo "pregmatch not found\r\n";
    if ($mode==0) {
      return False;
    } else {
      return $subj;
    }
  }  
}


function Get_origin_address($addr_msv,$msgf="") {
  if (isset($addr_msv[4])) {
    $res=$addr_msv[1].':'.$addr_msv[2].'/'.$addr_msv[3].($addr_msv[4]?'.'.$addr_msv[4]:'');
  } elseif (isset($addr_msv[3])) {
    $res=$addr_msv[1].':'.$addr_msv[2].'/'.$addr_msv[3];
  } else {
    $res = "0:0/0.0";
    logfile('E',"invalid origin line, get AKA failed: ".$msgf);
    logfile('D',"invalid origin line, get AKA failed: ".$msgf);      
  }
  unset($addr_msv);
  return $res;
}

//      $y = index($m_kludges, "MSGID:");
function index($s1,$s2) {
  $pos = at($s2,$s1);
  if ($pos > 0) {
    return $pos;
  }
  // check 0 pos
  if (substr($s1,0,strlen($s2))==$s2) {
    $pos = 0;
  } else {
    $pos = -1;
  }
  return $pos;  
}

// -----------------------------------------

function reorg1($folder="",$path="",$testmode=False) {
  global $prefix, $db1, $db2, $br, $dbname1, $dbname2;
  global $fbbs,$homepage, $baseurl, $areapath, $areap2, $prog, $sitename, $email;
  global $AllowableHTML, $locale;
  global $SRC_PATH, $imperr,$dpnfftscd,$dpnfsubj,$dpnfsuRe,$dpnfsuReMsg,$dpnfsuReDb;
  global $savmsg, $dupechkscnd;  

  $resc = array();
  $elist  = "0123456789abcdefghijklmnopqrstuvwxyz";
  $tabprefix = "echo_";
  $elpos = -1;

  while ($elpos < strlen($elist)) {
    $elpos++;
    $curtab = $tabprefix.substr($elist,$elpos,1);  
   
    // echo_#
    $idstart = -1;
    // $q1 = "select * from ".$dbname1.".echo_f where id > ".$idstart." order by id asc limit 1000;";
    // echo $short2U."\r\n";
    $mainloopstop = False;
  
    while (!$mainloopstop) {
      $q1 = "select * from ".$dbname1.".".$curtab." where id > ".$idstart." order by id asc limit 1000;";
      $idcnt = 0;
      $res1 = $db1->sql_query($q1);
      while ($row1 = $db1->sql_fetchrow($res1)) {
        $m_id       = intval($row1['id']);
        echo "importing table: ".$curtab.", id: ".$m_id."\r\n";
        $idstart = $m_id;
        $idcnt++;
        
        $m_ftscdate = substr($row1['ftscdate'],0,19);
        $m_datetime = $row1['datetime'];
        $m_folder   = $row1['folder'];
        $m_fromnode = $row1['fromnode'];
        $m_tonode   = $row1['tonode'];
        $m_fromname = stripslashes($row1['fromname']);
        $m_toname   = stripslashes($row1['toname']);
        $m_subject  = stripslashes($row1['subject']);
        $m_attrib   = intval($row1['attrib']);
        $m_msgid    = $row1['msgid'];
        $m_replyid  = $row1['replyid'];
        $m_origin   = stripslashes($row1['origin']);
        $m_path     = $row1['path'];
        $m_local    = $row1['local'];
        $m_rcvd     = $row1['rcvd'];
        $m_sent     = $row1['sent'];
        $m_kludges  = stripslashes($row1['kludges']);
        $m_body     = stripslashes($row1['body']);
        $m_seenby   = $row1['seenby'];
        $m_datewritten = $row1['datewritten'];
        $m_Uplink   = intval($row1['Uplink']);
    
    
        // normalize
        $originnode = "";
        $origin = "";
        $msgf = $m_id;
        // origin from db has no " * Origin: " !!!
        if ($m_origin!="") {
          /*
           # 17:58:13  missing msgid db1 rec id (4118)
           # 17:58:13         folder  : JOKES.GER
           # 17:58:13         ftscdate: 23 Jan 03  20:07:00
           # 17:58:13         msgid   : 
           # 17:58:13         subject : 2 einer noch :-)
           # 17:58:13            origin: <.^.> (2:240/2188.37)
           # 17:58:13           fromaka: 2:240/5138
           # 17:58:13         new msgid: 1:2320/105.999 40f6575e
          */    
    
          if (substr($m_origin,0,11)==" * Origin: ") {
            $origin  = substr($m_origin,11);
          } else {
            $origin = $m_origin;
          }
          if (preg_match('/\(([0-6]+):([0-9]+)\/([0-9]+)\.([0-9]+)\)/',$origin,$origAKA)) {        
            // found
          } elseif (preg_match('/\(([0-6]+):([0-9]+)\/([0-9]+)\)/',$origin,$origAKA)) {
            // found
          } else {
            // error on orig aka
            // from msgid ?
            if (!empty($m_msgid)) {
              if (preg_match('/([0-6]+):([0-9]+)\/([0-9]+)\.([0-9]+)/',$m_msgid,$origAKA)) {
                // try msgid
              } else {          
                $origAKA[0] = "";
                $origAKA[1] = "";
                $origAKA[2] = "";
                $origAKA[3] = "";
                $origAKA[4] = "";
              }          
            } else {          
              $origAKA[0] = "";
              $origAKA[1] = "";
              $origAKA[2] = "";
              $origAKA[3] = "";
              $origAKA[4] = "";
            }        
          }
          $originnode = Get_origin_address($origAKA,$msgf);
        }    
    
    
        if (empty($m_msgid)) {
          /*
           # 17:58:13  missing msgid db1 rec id (4118)
           # 17:58:13         folder  : JOKES.GER
           # 17:58:13         ftscdate: 23 Jan 03  20:07:00
           # 17:58:13         msgid   : 
           # 17:58:13         subject : 2 einer noch :-)
           # 17:58:13            origin: <.^.> (2:240/2188.37)
           # 17:58:13           fromaka: 2:240/5138
           # 17:58:13         new msgid: 1:2320/105.999 40f6575e
          */    
          /*
          logfile('D', "missing msgid db1 rec id (".$m_id.")");
          logfile('D', "       folder  : ".$m_folder);
          logfile('D', "       ftscdate: ".$m_ftscdate);
          logfile('D', "       msgid   : ".$m_msgid);      
          logfile('D', "       subject : ".$m_subject);
          logfile('D', "     originnode: ".$originnode);
          logfile('D', "         origin: ".$origin);
          logfile('D', "        fromaka: ".$m_fromnode);
           */              
          // create internal NOMSGID
          // # Extract MSGID ------------------------------------------------------
    
          if ($originnode!="") {
              $m_msgid = "NOMSGID ".$originnode." ".int32_to_hex( strcrc32($m_body));
          } else {
            $y = index($m_kludges, "MSGID:");
            if ( $y < 0 ) {
              $m_msgid = "NOMSGID ".$originnode." ".int32_to_hex( strcrc32($m_body));
            } else {
              $m_msgid = substr($m_kludges, $y + 7);
              $y = index($m_msgid, chr(1));
              if ( $y >= 0) {
                $m_msgid = substr($m_msgid, 0, $y );
              }
            }
          } 
          // logfile('D', "       new msgid: ".$m_msgid);
          if ($m_msgid!="") {
            if (array_key_exists('mmsd',$resc)) {
              $resc['mmsd']++;
            } else {
              $resc['mmsd'] = 1;
            }              
          } else {
            if (array_key_exists('mmus',$resc)) {
              $resc['mmus']++;
            } else {
              $resc['mmus'] = 1;
            }                    
          }
        }
    
        // remove Re's
        $m_subject = refn(1,$m_subject);
    
        // change umlauts
        $m_subject = umlaut($m_subject);
    
        // check subject length !!!
        if (strlen($m_subject)>72) {
          $m_subject = substr($m_subject,0,72);
          logfile('D', "db1 rec id (".$m_id."), subject stripped");
          logfile('D', "       folder  : ".$m_folder);
          logfile('D', "       ftscdate: ".$m_ftscdate);
          logfile('D', "       msgid   : ".$m_msgid);      
          logfile('D', "       subject : ".$m_subject);
        }
        
        // ftscdate differences may exists
    
        // dupecheck on fidobase2
        // includes normalized subject !!!
        $df = dupefind($m_id,$m_folder,$m_ftscdate,$m_msgid,$m_subject,$m_body);
        // echo "Memory usage: ".memory_get_usage() . "\n";
        if ($df == 0) {
          // save msg to db
          $datewritten = date('Y-m-d H:i:s'); 
          // echo "Now: ".$datewritten."\r\n";
    
          // normalize body 0Dh+0Ah to 0Dh
          $m_body     = strip0A($m_body);      
    
          // addslashes to all that needs slashes
          $m_fromname = addslashes($m_fromname);
          $m_toname   = addslashes($m_toname);
          $m_subject  = addslashes($m_subject);
          $m_origin   = addslashes($m_origin);
          $m_kludges  = addslashes($m_kludges);
          $m_body     = addslashes($m_body);
    
          // echo "save message to db\r\n";
          // use normalized values only
          if (savemsg($m_id,$m_ftscdate,$m_datetime,$m_folder,$m_fromnode,$m_tonode,$m_fromname,$m_toname,$m_subject,$m_attrib,$m_msgid,$m_replyid,$m_origin,$m_path,$m_local,$m_rcvd,$m_sent,$m_kludges,$m_body,$m_seenby,$m_datewritten,$m_Uplink)) {
            // echo "db1 id: ".$m_id." => stored db2.\r\n";
            // return True;
            if (array_key_exists($m_folder,$resc)) {
              $resc[$m_folder]++;
            } else {
              $resc[$m_folder] = 1;
            }
          } else {
            echo "db1 id: ".$m_id." => WARNING: message import failed. See Error log.\r\n";
            if (array_key_exists('failed',$resc)) {
              $resc['failed']++;
            } else {
              $resc['failed'] = 1;
            }        
          }
        } else {
          if ($df > 1) {
            logfile('D',"dupe found, skipped. db1 id: ".$m_id." (".($df>1?"extended":"MsgID").")");
          }
          if (array_key_exists('dupes',$resc)) {
            $resc['dupes']++;
          } else {
            $resc['dupes'] = 1;
          }                  
          // echo "exists.\r\n";
        }
      }
      $db1->sql_freeresult($res1);
      if ($idcnt < 1000) {
        $mainloopstop = True;    
      }
    }
  }
  
  $jj = count($resc);
  logfile('D',"Import summary:");
  $dup  = 0;
  $fail = 0;
  $mmsd = 0;
  $mmus = 0;
  ksort($resc);
  foreach ($resc as $rescn => $rescv) {
    if ($rescn=="dupes") {
      $dup = $rescv;
    } elseif ($rescn=="failed") {
      $fail = $rescv;
    } elseif ($rescn=="mmsd") {
      $mmsd = $rescv;
    } elseif ($rescn=="mmus") {
      $mmus = $rescv;
    } else {
      logfile('D',"Echo: ".$rescn.": ".$rescv);
    }    
  }
  logfile('D',"DUPES : ".$dup);  
  logfile('D',"FAILED: ".$fail);
  logfile('D',"Missing MsgID solved  : ".$mmsd);
  logfile('D',"Missing MsgID unsolved: ".$mmus);
  
  return TRUE;
}

/* ---------  end funtions  ------------------------------ */


?>
